/* Generated by Frama-C */
#include "stddef.h"
#include "stdint.h"
#include "stdio.h"
char *__gen_e_acsl_literal_string;
char *__gen_e_acsl_literal_string_2;
char *__gen_e_acsl_literal_string_4;
char *__gen_e_acsl_literal_string_3;
extern  __attribute__((__FC_BUILTIN__)) int __e_acsl_sound_verdict;

struct tree_desc {
   int *extra_bits ;
};
typedef struct tree_desc tree_desc;
struct tree_desc2 {
   struct tree_desc desc ;
};
typedef struct tree_desc2 tree_desc2;
static int extra_lbits[1] = {0};
static tree_desc l_desc = {.extra_bits = extra_lbits};
static tree_desc descs[2] =
  {{.extra_bits = extra_lbits}, {.extra_bits = extra_lbits}};
static tree_desc2 l_desc2 = {.desc = {.extra_bits = extra_lbits}};
static tree_desc2 descs2[2] =
  {{.desc = {.extra_bits = extra_lbits}},
   {.desc = {.extra_bits = extra_lbits}}};
void build_tree(tree_desc *desc)
{
  int *extra;
  __e_acsl_store_block((void *)(& extra),(size_t)8);
  __e_acsl_store_block((void *)(& desc),(size_t)8);
  __e_acsl_temporal_pull_parameter((void *)(& desc),0U,8UL);
  __e_acsl_full_init((void *)(& extra));
  __e_acsl_temporal_store_nreferent((void *)(& extra),
                                    (void *)(& desc->extra_bits));
  extra = desc->extra_bits;
  {
    int __gen_e_acsl_initialized;
    int __gen_e_acsl_and;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"&extra",
                                 (void *)(& extra));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                   "sizeof(int *)",0,sizeof(int *));
    __gen_e_acsl_initialized = __e_acsl_initialized((void *)(& extra),
                                                    sizeof(int *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                 "\\initialized(&extra)",0,
                                 __gen_e_acsl_initialized);
    if (__gen_e_acsl_initialized) {
      int __gen_e_acsl_valid;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"extra",
                                   (void *)extra);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid = __e_acsl_valid((void *)extra,sizeof(int),
                                          (void *)extra,(void *)(& extra));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                   "\\valid(extra)",0,__gen_e_acsl_valid);
      __gen_e_acsl_and = __gen_e_acsl_valid;
    }
    else __gen_e_acsl_and = 0;
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Assertion";
    __gen_e_acsl_assert_data.pred_txt = "\\valid(extra)";
    __gen_e_acsl_assert_data.file = "tests/temporal/t_global_init.c";
    __gen_e_acsl_assert_data.fct = "build_tree";
    __gen_e_acsl_assert_data.line = 34;
    __e_acsl_assert(__gen_e_acsl_and,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  /*@ assert \valid(extra); */ ;
  __e_acsl_delete_block((void *)(& desc));
  __e_acsl_delete_block((void *)(& extra));
  return;
}

char const *strings[2][2] = {{"the", "tha"}, {"thi", "tho"}};
void __e_acsl_globals_init(void)
{
  static char __e_acsl_already_run = 0;
  if (! __e_acsl_already_run) {
    __e_acsl_already_run = 1;
    __gen_e_acsl_literal_string = "tho";
    __e_acsl_store_block((void *)__gen_e_acsl_literal_string,sizeof("tho"));
    __e_acsl_full_init((void *)__gen_e_acsl_literal_string);
    __e_acsl_mark_readonly((void *)__gen_e_acsl_literal_string);
    __gen_e_acsl_literal_string_2 = "thi";
    __e_acsl_store_block((void *)__gen_e_acsl_literal_string_2,sizeof("thi"));
    __e_acsl_full_init((void *)__gen_e_acsl_literal_string_2);
    __e_acsl_mark_readonly((void *)__gen_e_acsl_literal_string_2);
    __gen_e_acsl_literal_string_4 = "the";
    __e_acsl_store_block((void *)__gen_e_acsl_literal_string_4,sizeof("the"));
    __e_acsl_full_init((void *)__gen_e_acsl_literal_string_4);
    __e_acsl_mark_readonly((void *)__gen_e_acsl_literal_string_4);
    __gen_e_acsl_literal_string_3 = "tha";
    __e_acsl_store_block((void *)__gen_e_acsl_literal_string_3,sizeof("tha"));
    __e_acsl_full_init((void *)__gen_e_acsl_literal_string_3);
    __e_acsl_mark_readonly((void *)__gen_e_acsl_literal_string_3);
    __e_acsl_store_block((void *)(descs2),(size_t)16);
    __e_acsl_full_init((void *)(& descs2));
    __e_acsl_store_block((void *)(& l_desc2),(size_t)8);
    __e_acsl_full_init((void *)(& l_desc2));
    __e_acsl_store_block((void *)(descs),(size_t)16);
    __e_acsl_full_init((void *)(& descs));
    __e_acsl_store_block((void *)(& l_desc),(size_t)8);
    __e_acsl_full_init((void *)(& l_desc));
    __e_acsl_store_block((void *)(extra_lbits),(size_t)4);
    __e_acsl_full_init((void *)(& extra_lbits));
    __e_acsl_store_block((void *)(strings),(size_t)32);
    __e_acsl_full_init((void *)(& strings));
    __e_acsl_temporal_store_nblock((void *)(& descs2[0].desc.extra_bits),
                                   (void *)(extra_lbits));
    __e_acsl_temporal_store_nblock((void *)(& descs2[1].desc.extra_bits),
                                   (void *)(extra_lbits));
    __e_acsl_temporal_store_nblock((void *)(& l_desc2.desc.extra_bits),
                                   (void *)(extra_lbits));
    __e_acsl_temporal_store_nblock((void *)(& descs[0].extra_bits),
                                   (void *)(extra_lbits));
    __e_acsl_temporal_store_nblock((void *)(& descs[1].extra_bits),
                                   (void *)(extra_lbits));
    __e_acsl_temporal_store_nblock((void *)(& l_desc.extra_bits),
                                   (void *)(extra_lbits));
    __e_acsl_temporal_store_nblock((void *)(& strings[0][0]),
                                   (void *)__gen_e_acsl_literal_string_4);
    __e_acsl_temporal_store_nblock((void *)(& strings[0][1]),
                                   (void *)__gen_e_acsl_literal_string_3);
    __e_acsl_temporal_store_nblock((void *)(& strings[1][0]),
                                   (void *)__gen_e_acsl_literal_string_2);
    __e_acsl_temporal_store_nblock((void *)(& strings[1][1]),
                                   (void *)__gen_e_acsl_literal_string);
  }
  return;
}

void __e_acsl_globals_clean(void)
{
  __e_acsl_delete_block((void *)(descs2));
  __e_acsl_delete_block((void *)(& l_desc2));
  __e_acsl_delete_block((void *)(descs));
  __e_acsl_delete_block((void *)(& l_desc));
  __e_acsl_delete_block((void *)(extra_lbits));
  __e_acsl_delete_block((void *)(strings));
  return;
}

int main(int argc, char const **argv)
{
  int __retres;
  __e_acsl_memory_init(& argc,(char ***)(& argv),(size_t)8);
  __e_acsl_globals_init();
  __e_acsl_temporal_reset_parameters();
  __e_acsl_temporal_reset_return();
  __e_acsl_temporal_save_nblock_parameter((void *)(& l_desc),0U);
  build_tree(& l_desc);
  __e_acsl_temporal_reset_parameters();
  __e_acsl_temporal_reset_return();
  __e_acsl_temporal_save_nblock_parameter((void *)(descs),0U);
  build_tree(descs);
  __e_acsl_temporal_reset_parameters();
  __e_acsl_temporal_reset_return();
  __e_acsl_temporal_save_nblock_parameter((void *)(& descs[1]),0U);
  build_tree(& descs[1]);
  __e_acsl_temporal_reset_parameters();
  __e_acsl_temporal_reset_return();
  __e_acsl_temporal_save_nblock_parameter((void *)(& l_desc2.desc),0U);
  build_tree(& l_desc2.desc);
  __e_acsl_temporal_reset_parameters();
  __e_acsl_temporal_reset_return();
  __e_acsl_temporal_save_nblock_parameter((void *)(& descs2[0].desc),0U);
  build_tree(& descs2[0].desc);
  __e_acsl_temporal_reset_parameters();
  __e_acsl_temporal_reset_return();
  __e_acsl_temporal_save_nblock_parameter((void *)(& descs2[1].desc),0U);
  build_tree(& descs2[1].desc);
  char **p = (char **)(strings);
  __e_acsl_temporal_store_nblock((void *)(& p),(void *)(strings));
  __e_acsl_store_block((void *)(& p),(size_t)8);
  __e_acsl_full_init((void *)(& p));
  {
    int __gen_e_acsl_initialized;
    int __gen_e_acsl_and;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"&p",
                                 (void *)(& p));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                   "sizeof(char **)",0,sizeof(char **));
    __gen_e_acsl_initialized = __e_acsl_initialized((void *)(& p),
                                                    sizeof(char **));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                 "\\initialized(&p)",0,
                                 __gen_e_acsl_initialized);
    if (__gen_e_acsl_initialized) {
      int __gen_e_acsl_valid_read;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"p",(void *)p);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                     "sizeof(char *)",0,sizeof(char *));
      __gen_e_acsl_valid_read = __e_acsl_valid_read((void *)p,sizeof(char *),
                                                    (void *)p,(void *)(& p));
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                   "\\valid_read(p)",0,
                                   __gen_e_acsl_valid_read);
      __gen_e_acsl_and = __gen_e_acsl_valid_read;
    }
    else __gen_e_acsl_and = 0;
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Assertion";
    __gen_e_acsl_assert_data.pred_txt = "\\valid_read(p)";
    __gen_e_acsl_assert_data.file = "tests/temporal/t_global_init.c";
    __gen_e_acsl_assert_data.fct = "main";
    __gen_e_acsl_assert_data.line = 49;
    __e_acsl_assert(__gen_e_acsl_and,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  /*@ assert \valid_read(p); */ ;
  {
    int __gen_e_acsl_initialized_2;
    int __gen_e_acsl_and_3;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_2 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"p",(void *)p);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                   "sizeof(char *)",0,sizeof(char *));
    __gen_e_acsl_initialized_2 = __e_acsl_initialized((void *)p,
                                                      sizeof(char *));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,
                                 "\\initialized(p)",0,
                                 __gen_e_acsl_initialized_2);
    if (__gen_e_acsl_initialized_2) {
      int __gen_e_acsl_initialized_3;
      int __gen_e_acsl_and_2;
      int __gen_e_acsl_valid_read_3;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"*p",
                                   (void *)*p);
      __e_acsl_assert_data_t __gen_e_acsl_assert_data_3 =
        {.values = (void *)0};
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_3,"&p",
                                   (void *)(& p));
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_3,
                                     "sizeof(char **)",0,sizeof(char **));
      __gen_e_acsl_initialized_3 = __e_acsl_initialized((void *)(& p),
                                                        sizeof(char **));
      if (__gen_e_acsl_initialized_3) {
        int __gen_e_acsl_valid_read_2;
        __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_3,"p",
                                     (void *)p);
        __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_3,
                                       "sizeof(char *)",0,sizeof(char *));
        __gen_e_acsl_valid_read_2 = __e_acsl_valid_read((void *)p,
                                                        sizeof(char *),
                                                        (void *)p,
                                                        (void *)(& p));
        __gen_e_acsl_and_2 = __gen_e_acsl_valid_read_2;
      }
      else __gen_e_acsl_and_2 = 0;
      __gen_e_acsl_assert_data_3.blocking = 1;
      __gen_e_acsl_assert_data_3.kind = "RTE";
      __gen_e_acsl_assert_data_3.pred_txt = "mem_access: \\valid_read(p)";
      __gen_e_acsl_assert_data_3.file = "tests/temporal/t_global_init.c";
      __gen_e_acsl_assert_data_3.fct = "main";
      __gen_e_acsl_assert_data_3.line = 50;
      __e_acsl_assert(__gen_e_acsl_and_2,& __gen_e_acsl_assert_data_3);
      __e_acsl_assert_clean(& __gen_e_acsl_assert_data_3);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                     "sizeof(char)",0,sizeof(char));
      __gen_e_acsl_valid_read_3 = __e_acsl_valid_read((void *)*p,
                                                      sizeof(char),
                                                      (void *)*p,(void *)p);
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,
                                   "\\valid_read(*p)",0,
                                   __gen_e_acsl_valid_read_3);
      __gen_e_acsl_and_3 = __gen_e_acsl_valid_read_3;
    }
    else __gen_e_acsl_and_3 = 0;
    __gen_e_acsl_assert_data_2.blocking = 1;
    __gen_e_acsl_assert_data_2.kind = "Assertion";
    __gen_e_acsl_assert_data_2.pred_txt = "\\valid_read(*p)";
    __gen_e_acsl_assert_data_2.file = "tests/temporal/t_global_init.c";
    __gen_e_acsl_assert_data_2.fct = "main";
    __gen_e_acsl_assert_data_2.line = 50;
    __e_acsl_assert(__gen_e_acsl_and_3,& __gen_e_acsl_assert_data_2);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_2);
  }
  /*@ assert \valid_read(*p); */ ;
  __retres = 0;
  __e_acsl_delete_block((void *)(& p));
  __e_acsl_globals_clean();
  __e_acsl_memory_clean();
  return __retres;
}


